﻿screen phone_button(c = phone_in_use):
    timer .1 repeat True action Function(c.tick)
    # vbox:
    #     align .3,.3
    #     if c.active:
    #         text c.active.typing
    button:
        if c.wiggle:
            at wiggle
        background None xalign 1.0 
        add "phone/smartphone.png"
        action ToggleScreen("phone", c = phone_in_use)

transform wiggle:
    rotate_pad False
    subpixel True
    ease .1 rotate -4
    ease .1 rotate 4
    repeat

screen phone(c):
    tag phone
    
    frame:
        xysize(600,900) padding(0,0) background "phone/5.jpg"

        frame: # TOp bar
            ysize 40 yalign 0.0 xfill True background "#0009"
            fixed:
                hbox:
                    xalign 1.0
                    text "4G iii"
                    text "100% B"
                hbox:
                    xalign 0.0
                    text "*"
                    text "2 new messages"

        hbox:
            button:
                background None
                add "phone/calls.png"
            button:
                background None
                fixed:
                    fit_first True
                    add "phone/sms.png"
                    # if c.unread:
                    #     frame:
                    #         background "#f00" offset 40,40 xysize 40,40
                    #         text str(c.unread) color "#fff"
                action Function(c.show, "sms list")
            button:
                background None
                add "phone/contacts.png"

screen phone_sms_list(c):
    tag phone
    frame:
        xysize(600,900) padding(10,10) background "#222"
        vbox:
            yalign 0.0
            for i in c.contacts:
                if len(i.sms):
                    button:
                        xfill True background "#333b" 
                        vbox:
                            xalign 0.0
                            if i.name:
                                text i.name xalign 0.0
                            else:
                                text _("Unknown") xalign 0.0
                            text i.sms[-1][1] xalign 0.0
                        action Function(c.show, "sms", i.id)



transform phone_crop:
    crop(0,0,600,700)



screen phone_sms(c = phone_in_use):
    tag phone

    frame:
        xysize(600,900) padding(10,10) background "#222"
        if c.active:
            frame: # Header
                ysize 80 xfill True yalign 0.0 background "#333b"
                if c.active.name:
                    text c.active.name
                else:
                    text _("Unknown")

            frame: # Main body
                background None padding (30,80,30,110) yfill True
                viewport id "phone_vp":
                    draggable True scrollbars None yinitial 1.0
                    xfill False
                    yfill False
                    yalign 1.0
                    frame:
                        padding(0,0) background None
                        vbox:
                            xfill True spacing 2
                            for n, i in enumerate(c.active.sms):
                                if isinstance(i, basestring):
                                    pass
                                else:
                                    if i[0] == c.id:
                                        if not n or not c.active.sms[n-1][0] == i[0]:
                                            null height 20
                                            hbox:
                                                xalign 1.0 spacing 0
                                                frame:
                                                    style "phone_right" xoffset 64
                                                    text i[1] color "#000"
                                                if c.img:
                                                    add c.img yalign 0.0
                                                else:
                                                    add "phone/img.png" yalign 0.0
                                        else:
                                            frame:
                                                xalign 1.0
                                                style "phone_right_1"
                                                text i[1] color "#000"

                                    else:
                                        if not n or not c.active.sms[n-1][0] == i[0]:
                                            null height 20
                                            hbox:
                                                xalign 0.0 spacing 0
                                                if c.active.img:
                                                    add c.active.img yalign 0.0
                                                else:
                                                    add "phone/img.png" yalign 0.0
                                                frame:
                                                    style "phone_left" xoffset -64
                                                    text i[1] color "#000"
                                        else:
                                            frame:
                                                xalign 0.0
                                                style "phone_left_1"
                                                text i[1] color "#000"

            vbox: # Input
                yalign 1.0 spacing 0
                if c.active.current:
                    if c.active.phase == 1:
                        text "{} is typing...".format(c.active.name) size 15 xalign 0.0

                frame:
                    background "#333b" padding 10,10 xfill True
                    has hbox
                    xfill True
                    if c.active.typing:
                        frame:
                            xsize 420 padding 0,0 background None
                            text c.active.typing xalign 0.0
                    else:
                        text "Type text message..." xalign 0.0
                    button:
                        xalign 1.0 ysize 62 background "#222"
                        text "Send"
                        if c.active.phase == 3:
                            action Function(c.active.send)


style phone_right:
    background Frame(im.Flip("phone/frm0.png",True), 10,20,76,10)
    padding(32,12,96,12)
    yminimum 64
    xmaximum 500

style phone_left:
    background Frame("phone/frm0.png", 76,20,10,10)
    padding(96,12,32,12)
    yminimum 64
    xmaximum 500
style phone_right_1:
    background Frame(im.Flip("phone/frm1.png",True), 10,20,76,10)
    padding(32,12,96,12)
    yminimum 64
    xmaximum 500
style phone_left_1:
    background Frame("phone/frm1.png", 76,20,10,10)
    padding(96,12,32,12)
    yminimum 64
    xmaximum 500